var solr = require('solr');
var solrClient = solr.createClient();
var crypto = require('crypto');
var sys = require('sys');
/*
* VERY SEVERE HACK BUT IT GETS THE WORK DONE. DARN NODE.JS FOR NOT HAVING AN ADMIN INTERFACE LIKE DJANGO!!!!!
* This web app lets you create categories and outcomes, which is stored in our redis db
*/

function createSolrIndex(title, callback){
  var salt = Math.round((new Date().valueOf() * Math.random())) + '';
  var hmac = crypto.createHmac('sha1', salt).update(title);
  var digest = hmac.digest('hex');
  
  return callback(digest);
}

/////// ROUTES /////////////
module.exports = function(server) {
  //Random Landing Page for testing
  server.get('/', function (req,res) {
    server.rsClient.SMEMBERS('global:categories', function(err,data) {
      console.log(data);
      if(data){
        res.end(sys.inspect(data));
      }
      else{
        res.end('failed');
      }
    });
  });
  
  /*
  * Create a new Category
  */
  server.get('/create/category', function(req,res) {
    res.local('title', 'Create Category - Riiple');
    res.local('description', 'Disrupting known methods!');
    res.local('analyticssiteid', 'XXXXXXX');
    res.local('source', 'category');
    
    //Just display
    res.render('category');
  });
  
  /*
  * Create Categories and Add their outcomes as well
  */
  server.post( '/create/category', function ( req, res ) {
    var categoryTitle = req.body.param_category;
    var outcome1 = req.body.param_outcome1;
    var outcome2 = req.body.param_outcome2;
    var outcome3 = req.body.param_outcome3;
    var outcome4 = req.body.param_outcome4;
    var outcome5 = req.body.param_outcome5;
    
    //once we have the data, we store it in the database
    server.rsClient.incr( 'global:categoryId', function ( err, id ) {
      if ( id ) {
       
        /*
        * First save the category
        */
       
        var category_id = id;
        console.log( 'categoryId '+category_id );
        server.rsClient.set( 'category:'+category_id+':title', categoryTitle ); //Save the title
        server.rsClient.set( 'category:'+escape(categoryTitle.toUpperCase())+':id', id ); //Make id retrievable from the category title
        
        // We need a global key to access the id's of all categories
        server.rsClient.sadd( 'global:categories',category_id ); //This is a set containing all the category Id's
        
        /*
        * Save the outcomes
        */
        
        //Topic1
        server.rsClient.incr('global:topicId', function (err,id) {
          if (id) {
            var topicId = id;
            console.log( 'topicId1 '+topicId );
            server.rsClient.set( 'topic:'+topicId+':title', outcome1 ); // Save the title of the topic
            server.rsClient.set( 'topic:'+escape(outcome1.toUpperCase())+':id', id ); //Save the topic name
            server.rsClient.set( 'topic:'+topicId+':category:id', category_id ); //Save its category name
            
            createSolrIndex( outcome1, function ( index ) {
              server.rsClient.set( 'topic:'+topicId+':solrIndex', index ); //In case we need to update this topic   
              /*
              * Now create the document to be saved to solr for searching
              */
              var doc = {
                id: index,
                entity_s: 'topic',
                topicId_i: topicId,
                title: outcome1,
              };

              var callback = function ( err, response ) {
                if ( err ) throw err;
                console.log('Document added');
              };
              
              //Add the documents to the database
              solrClient.add( doc, callback ); // adds the index to solr (not yet visible tho)
              solrClient.commit(); // Updates the index by committing any changes since last commit
              
            });
            
            //Add the outcome to the category set
            server.rsClient.sadd('category:'+category_id+':topicIds', id); // A set of the categories topic's
          }
          else{}
        }); /* End Topic Code */
        
        //Topic2
        server.rsClient.incr('global:topicId', function (err,id) {
          if (id) {
            var topicId = id;
            console.log( 'topicId1 '+topicId );
            server.rsClient.set( 'topic:'+topicId+':title', outcome2 ); // Save the title of the topic
            server.rsClient.set( 'topic:'+escape(outcome2.toUpperCase())+':id', id ); //Save the topic name
            server.rsClient.set( 'topic:'+topicId+':category:id', category_id ); //Save its category name
            
            createSolrIndex( outcome2, function ( index ) {
              server.rsClient.set( 'topic:'+topicId+':solrIndex', index ); //In case we need to update this topic   
              /*
              * Now create the document to be saved to solr for searching
              */
              var doc = {
                id: index,
                entity_s: 'topic',
                topicId_i: topicId,
                title: outcome2,
              };

              var callback = function ( err, response ) {
                if ( err ) throw err;
                console.log('Document added');
              };
              
              //Add the documents to the database
              solrClient.add( doc, callback ); // adds the index to solr (not yet visible tho)
              solrClient.commit(); // Updates the index by committing any changes since last commit
              
            });
            
            //Add the outcome to the category set
            server.rsClient.sadd('category:'+category_id+':topicIds', id); // A set of the categories topic's
          }
          else{}
        }); /* End Topic Code */
        
        //Topic3
        server.rsClient.incr('global:topicId', function (err,id) {
          if (id) {
            var topicId = id;
            console.log( 'topicId1 '+topicId );
            server.rsClient.set( 'topic:'+topicId+':title', outcome3 ); // Save the title of the topic
            server.rsClient.set( 'topic:'+escape(outcome3.toUpperCase())+':id', id ); //Save the topic name
            server.rsClient.set( 'topic:'+topicId+':category:id', category_id ); //Save its category name
            
            createSolrIndex( outcome3, function ( index ) {
              server.rsClient.set( 'topic:'+topicId+':solrIndex', index ); //In case we need to update this topic   
              /*
              * Now create the document to be saved to solr for searching
              */
              var doc = {
                id: index,
                entity_s: 'topic',
                topicId_i: topicId,
                title: outcome3,
              };

              var callback = function ( err, response ) {
                if ( err ) throw err;
                console.log('Document added');
              };
              
              //Add the documents to the database
              solrClient.add( doc, callback ); // adds the index to solr (not yet visible tho)
              solrClient.commit(); // Updates the index by committing any changes since last commit
              
            });
            
            //Add the outcome to the category set
            server.rsClient.sadd('category:'+category_id+':topicIds', id); // A set of the categories topic's
          }
          else{}
        }); /* End Topic Code */
        
        //Topic4
        server.rsClient.incr('global:topicId', function (err,id) {
          if (id) {
            var topicId = id;
            console.log( 'topicId1 '+topicId );
            server.rsClient.set( 'topic:'+topicId+':title', outcome4 ); // Save the title of the topic
            server.rsClient.set( 'topic:'+escape(outcome4.toUpperCase())+':id', id ); //Save the topic name
            server.rsClient.set( 'topic:'+topicId+':category:id', category_id ); //Save its category name
            
            createSolrIndex( outcome4, function ( index ) {
              server.rsClient.set( 'topic:'+topicId+':solrIndex', index ); //In case we need to update this topic   
              /*
              * Now create the document to be saved to solr for searching
              */
              var doc = {
                id: index,
                entity_s: 'topic',
                topicId_i: topicId,
                title: outcome4,
              };

              var callback = function ( err, response ) {
                if ( err ) throw err;
                console.log('Document added');
              };
              
              //Add the documents to the database
              solrClient.add( doc, callback ); // adds the index to solr (not yet visible tho)
              solrClient.commit(); // Updates the index by committing any changes since last commit
              
            });
            
            //Add the outcome to the category set
            server.rsClient.sadd('category:'+category_id+':topicIds', id); // A set of the categories topic's
          }
          else{}
        }); /* End Topic Code */
        
        //Topic5
        server.rsClient.incr('global:topicId', function (err,id) {
          if (id) {
            var topicId = id;
            console.log( 'topicId5 '+topicId );
            server.rsClient.set( 'topic:'+topicId+':title', outcome5 ); // Save the title of the topic
            server.rsClient.set( 'topic:'+escape(outcome5.toUpperCase())+':id', id ); //Save the topic name
            server.rsClient.set( 'topic:'+topicId+':category:id', category_id ); //Save its category name
            
            createSolrIndex( outcome5, function ( index ) {
              server.rsClient.set( 'topic:'+topicId+':solrIndex', index ); //In case we need to update this topic   
              /*
              * Now create the document to be saved to solr for searching
              */
              var doc = {
                id: index,
                entity_s: 'topic',
                topicId_i: topicId,
                title: outcome5,
              };

              var callback = function ( err, response ) {
                if ( err ) throw err;
                console.log('Document added');
              };
              
              //Add the documents to the database
              solrClient.add( doc, callback ); // adds the index to solr (not yet visible tho)
              solrClient.commit(); // Updates the index by committing any changes since last commit
              
            });
            
            //Add the outcome to the category set
            server.rsClient.sadd('category:'+category_id+':topicIds', id); // A set of the categories topic's
          }
          else{}
        }); /* End Topic Code */
        
        
        /*
        * Now save the category to solr
        */
        createSolrIndex( categoryTitle, function(index){
          server.rsClient.set('category:'+category_id+':solrIndex', index); // Create its solr index
          /*
          * Now create the document to be saved to solr for searching
          */
          var doc = {
            id: index,
            entity_s: 'category',
            categoryId_i: category_id,
            title: categoryTitle,
          };

          var callback = function(err, response) {
            if (err) throw err;
            console.log('Document added');
          };

          //Add the documents to the database
          solrClient.add(doc, callback); // adds the index to solr (not yet visible tho)
          solrClient.commit(); // Updates the index by committing any changes since last commit
        });
      }
      else{
        //throw an error
      }
    });
    //Just display
    res.render('categorydone');
  });
};